/***
 * Excerpted from "Rails For Java Programmers"
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/fr_r4j for more book information.
***/
package com.relevancellc.people.dao.hibernate;

import com.relevancellc.people.model.Person;
import com.relevancellc.people.dao.PersonDao;
import org.springframework.orm.ObjectRetrievalFailureException;

import java.util.List;

public class PersonDaoHibernate extends BaseDaoHibernate implements PersonDao {

  public Person getPerson(Long id) {
    Person person = (Person) getHibernateTemplate().get(Person.class, id);

    if (person == null) {
      throw new ObjectRetrievalFailureException(Person.class, id);
    }

    return person;
  }

  public void savePerson(Person person) {
    getHibernateTemplate().saveOrUpdate(person);
  }

  public void removePerson(Long id) {
    // object must be loaded before it can be deleted
    getHibernateTemplate().delete(getPerson(id));
  }

  //START:getPeople
  public List getPeople(Person person) {
    return getHibernateTemplate().find("from Person");
  }
  //END:getPeople
}