/***
 * Excerpted from "Rails For Java Programmers"
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/fr_r4j for more book information.
***/
package com.relevancellc.people.model;

/**
 * @hibernate.class table="person"
 * @struts.form include-all="true" extends="BaseForm"
 * @axisfuse.beanMapping
 * xmlns="http://model.appfuse.org"
 */
public class Person extends BaseObject {
  private Long id;
  private String firstName;
  private String lastName;

  /**
   * @hibernate.id column="id" generator-class="native" unsaved-value="null"
   */
  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  //START:getFirstName
  /**
   * @hibernate.property column="first_name" length="50"
   * @struts.validator type="required"
   */
  public String getFirstName() {
    return firstName;
  }
  //END:getFirstName
  public void setFirstName(String firstName) {
    this.firstName = firstName;
  }

  /**
   * @hibernate.property column="last_name" length="50"
   * @struts.validator type="required"
   */
  public String getLastName() {
    return lastName;
  }

  public void setLastName(String lastName) {
    this.lastName = lastName;
  }

  public boolean equals(Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;

    final Person person = (Person) o;

    if (id != person.id) return false;
    if (firstName != null ? !firstName.equals(person.firstName) : person.firstName != null) return false;
    if (lastName != null ? !lastName.equals(person.lastName) : person.lastName != null) return false;

    return true;
  }

  public int hashCode() {
    int result;
    result = (int) (id.longValue() ^ (id.longValue() >>> 32));
    result = 29 * result + (firstName != null ? firstName.hashCode() : 0);
    result = 29 * result + (lastName != null ? lastName.hashCode() : 0);
    return result;
  }

  public String toString() {
    return "Person " + firstName + " " + lastName;
  }
}
