/***
 * Excerpted from "Rails For Java Programmers"
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/fr_r4j for more book information.
***/
package com.relevancellc.people.webapp.filter;

import org.apache.commons.logging.*;

import javax.servlet.*;
import javax.servlet.http.HttpServletRequest;
import java.io.IOException;

public class LoggingFilter implements Filter {
  protected final Log log = LogFactory.getLog(getClass());
  public void init(FilterConfig filterConfig)
      throws ServletException {
  }
  //START:doFilter
  public void 
  doFilter(ServletRequest req, ServletResponse resp, FilterChain filterChain)
      throws IOException, ServletException {
    if (log.isDebugEnabled()) {
      HttpServletRequest r= (HttpServletRequest)req;
      log.debug("Entering " + r.getRequestURI());
    }
    filterChain.doFilter(req, resp);
  }
  //END:doFilter
  public void destroy() {
  }
}
