/***
 * Excerpted from "Rails For Java Programmers"
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/fr_r4j for more book information.
***/
package com.relevancellc.people.webapp.action;

import com.relevancellc.people.Constants;
import com.relevancellc.people.webapp.form.PersonForm;

public class PersonActionTest extends BaseStrutsTestCase {
  public PersonActionTest(String name) {
    super(name);
  }

  public void testEdit()
      throws Exception {
    setRequestPathInfo("/editPerson");
    addRequestParameter("method", "Edit");
    addRequestParameter("id", "1");
    actionPerform();

    verifyForward("edit");
    assertTrue(request.getAttribute(Constants.PERSON_KEY) != null);
    verifyNoActionErrors();
  }

  public void testSave()
      throws Exception {
    setRequestPathInfo("/editPerson");
    addRequestParameter("method", "Edit");
    addRequestParameter("id", "1");

    actionPerform();

    PersonForm personForm =
        (PersonForm) request.getAttribute(Constants.PERSON_KEY);
    assertTrue(personForm != null);

    setRequestPathInfo("/savePerson");
    addRequestParameter("method", "Save");

    // update the form from the edit and add it back to the request
    personForm.setLastName("Feltz");
    request.setAttribute(Constants.PERSON_KEY, personForm);

    actionPerform();

    verifyForward("viewPeople");
    verifyNoActionErrors();
  }

  public void testRemove()
      throws Exception {
    setRequestPathInfo("/editPerson");
    addRequestParameter("method", "Delete");
    addRequestParameter("id", "2");
    actionPerform();

    verifyForward("viewPeople");
    verifyNoActionErrors();
  }


  public void testSearch() {
    setRequestPathInfo("/editPerson");
    addRequestParameter("method", "Search");
    actionPerform();

    verifyForward("list");

    assertNotNull(getRequest().getAttribute(Constants.PERSON_LIST));
    verifyNoActionErrors();
  }
}
