/***
 * Excerpted from "Rails For Java Programmers"
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/fr_r4j for more book information.
***/
import junit.framework.TestCase;

import java.util.*;

import org.hibernate.Session;

public class Relationships extends SessionTest {
  public void testOneToMany() {
    //START:one-to-many
    sess.beginTransaction();
    Person person = new Person();
    person.setFirstName("John");
    Quip q = new Quip();
    q.setText("A stitch in time...");
    q.setAuthor(person);            //<label id="ar.association.set.author"/>
    HashSet hs = new HashSet();
    hs.add(q);
    person.setQuips(hs);            //<label id="ar.association.set.quips"/>
    sess.save(person);              //<label id="ar.association.save"/>
    sess.getTransaction().commit(); 
    //END:one-to-many
    assertTrue(0 != person.getId());
    assertTrue(0 != q.getId());
  }

  public void testInheritance() {
    sess.beginTransaction();
    Star s = new Star();
    s.setClassification("B");
    s.setName("Rigel");
    sess.save(s);
    Planet p = new Planet();
    p.setName("Mercury");
    p.setGasGiant(false);
    sess.save(p);
    sess.getTransaction().commit();
  }

  public void testQuery() {
    sess.beginTransaction();
    List list = sess.createQuery("from CelestialBody").list();
    for (Iterator it = list.iterator(); it.hasNext();) {
      CelestialBody b =  (CelestialBody) it.next();
      assert(b instanceof Star || b instanceof Planet);
    }
  }
}
