/***
 * Excerpted from "Rails For Java Programmers"
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/fr_r4j for more book information.
***/
import org.hibernate.classic.Session;
import org.hibernate.criterion.Expression;
import org.hibernate.*;

import java.util.*;

/**
 * Created by IntelliJ IDEA.
 * User: stuart
 * Date: Aug 22, 2006
 * Time: 7:13:00 AM
 * To change this template use File | Settings | File Templates.
 */
public class TransactionTest extends SessionTest {
  public void testNPlusOne() {
    //START:hqlHint
    Criteria c = sess.createCriteria(Person.class)
                     .setFetchMode("quips", FetchMode.JOIN);
    Set people = new HashSet(c.list());
    //END:hqlHint
    //START:xt
    assertEquals(2, people.size());
    sess.close();
    for (Iterator iterator = people.iterator(); iterator.hasNext();) {
      Person p = (Person) iterator.next();
      assertEquals(25, p.getQuips().size());
    }
    //END:xt
  }

  public void testRawSQL() {
    //START:rawSql
    SQLQuery q = sess.createSQLQuery("SELECT p.* FROM PEOPLE p")
                     .addEntity(Person.class);
    Set people = new HashSet(q.list());
    //END:rawSql
    assertEquals(2, people.size());
  }

  public void testConflictingUpdate() {
    Session sess2 = HibernateUtil.sf.openSession();
    try {
      Person p1 = (Person) sess.get(Person.class, 1L);
      Person p2 = (Person) sess2.get(Person.class, 1L);

      p1.setUrl("www.sample.org");
      sess.save(p1);
      sess.flush();

      p2.setUrl("www.sample.net");
      sess2.save(p2);
      //TODO: this should fail, instead it hangs
      sess2.flush();
    } finally {
      sess2.close();
    }

  }
}
