/***
 * Excerpted from "Rails For Java Programmers"
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/fr_r4j for more book information.
***/
import org.hibernate.validator.*;

import javax.persistence.*;
import java.util.Date;
import java.security.*;

import org.apache.commons.codec.*;
import org.apache.commons.codec.binary.Hex;

@Entity
@Table(name="users")
public class User {
  Long id;
  private String login;
  private String email;
  private String cryptedPassword;
  private String salt;
  private Date createdAt;
  private Date updatedAt;
  private String rememberToken;
  private Date rememberTokenExpiresAt;

  private String password;
  @Transient
  public String getPassword() {
    return password;
  }
  public void setPassword(String password) {
    this.password = password;
  }

  public String hash(String s)
      throws NoSuchAlgorithmException {
    String input = "--" + salt + "--" + s + "--";
    MessageDigest md = MessageDigest.getInstance("SHA1");
    byte[] bytes = md.digest(input.getBytes());
    return new String(Hex.encodeHex(bytes));
  }

  public void hashPassword()
      throws NoSuchAlgorithmException {
    if (password != null) {
      if (salt == null) {
        MessageDigest md = MessageDigest.getInstance("SHA1");
        String date = new Date().toString();
        byte[] bytes = md.digest(date.getBytes());
        this.setSalt(new String(Hex.encodeHex(bytes)));
      }
      this.setPassword(hash(password));
      password = null;
    }
  }

  @Id @GeneratedValue(strategy=GenerationType.IDENTITY)
  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  //START:constraints
  @NotNull
  @Length(min=3,max=40)
  public String getLogin() {
    return login;
  }
  //END:constraints

  public void setLogin(String login) {
    this.login = login;
  }

  @NotNull
  @Length(min=3,max=100)
  public String getEmail() {
    return email;
  }

  public void setEmail(String email) {
    this.email = email;
  }

  @Column(name="crypted_password")
  public String getCryptedPassword() {
    return cryptedPassword;
  }

  public void setCryptedPassword(String cryptedPassword) {
    this.cryptedPassword = cryptedPassword;
  }

  public String getSalt() {
    return salt;
  }

  public void setSalt(String salt) {
    this.salt = salt;
  }

  @Column(name="created_at")
  public Date getCreatedAt() {
    return createdAt;
  }

  public void setCreatedAt(Date createdAt) {
    this.createdAt = createdAt;
  }

  @Column(name="updated_at")
  public Date getUpdatedAt() {
    return updatedAt;
  }

  public void setUpdatedAt(Date updatedAt) {
    this.updatedAt = updatedAt;
  }

  @Column(name="remember_token")
  public String getRememberToken() {
    return rememberToken;
  }

  public void setRememberToken(String rememberToken) {
    this.rememberToken = rememberToken;
  }

  @Column(name="remember_token_expires_at")
  public Date getRememberTokenExpiresAt() {
    return rememberTokenExpiresAt;
  }

  public void setRememberTokenExpiresAt(Date rememberTokenExpiresAt) {
    this.rememberTokenExpiresAt = rememberTokenExpiresAt;
  }
}
