/***
 * Excerpted from "Rails For Java Programmers"
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/fr_r4j for more book information.
***/
import org.hibernate.event.def.*;
import org.hibernate.event.SaveOrUpdateEvent;
import org.hibernate.HibernateException;
import java.security.NoSuchAlgorithmException;

//START:lifecycle
public class UserEventListener extends DefaultSaveOrUpdateEventListener {
  public void onSaveOrUpdate(SaveOrUpdateEvent event)
      throws HibernateException {
    Object o = event.getObject();
    if (o instanceof User) {          //<label id="co.ar.lifecycle.instanceof"/>
      try {
        ((User) o).hashPassword();    //<label id="co.ar.lifecycle.hashPassword"/>
      } catch (NoSuchAlgorithmException e) {
        throw new HibernateException(e);
      }
    }
    super.onSaveOrUpdate(event);
  }
}
//END:lifecycle
