/***
 * Excerpted from "Rails For Java Programmers"
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/fr_r4j for more book information.
***/
import java.io.*;

/**
 * Created by Stuthulhu: Jun 6, 2006
 */
public class DemoException {
  public static void main(String[] args) {
    //START:catchUnchecked
    try {
      methodThatDividesByZero();
    } catch (Exception e) {
      System.out.println(e.getMessage());
      e.printStackTrace();
    }
    //END:catchUnchecked
    //START:catchChecked
    try {
      methodThatOpensFile();
    } catch (FileNotFoundException fnfe) {
      System.out.println("File not found " + fnfe);
    } catch (Exception e) {
      System.out.println("Caught " + e);
    }
    //END:catchChecked
  }

  //START:throwUnchecked
  static void methodThatDividesByZero() {
    int z = 0;
    int ten = 10;
    int in = ten/z;
  }
  //END:throwUnchecked

  //START:throwChecked
  static void methodThatOpensFile()
      throws FileNotFoundException {
    new FileInputStream("nonexistent.file");
  }
  //END:throwChecked
}
