/***
 * Excerpted from "Rails For Java Programmers"
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/fr_r4j for more book information.
***/
package poly;

import java.util.ArrayList;

//START:implements
public class BusinessPerson
    implements Person, Employee, Employer {
//END:implements
  private String lastName;
  private String firstName;
  private Employer employer;
  private EmployerImpl employerImpl;
  public BusinessPerson(String firstName, String lastName) {
    this.firstName = firstName;
    this.lastName = lastName;
    employerImpl = new EmployerImpl();
  }

  public String getLastName() {
    return lastName;
  }

  public void setLastName(String lastName) {
    this.lastName = lastName;
  }

  public String getFirstName() {
    return firstName;
  }

  public void setFirstName(String firstName) {
    this.firstName = firstName;
  }

  public void marry(Person other) {
    String newLastName = String.format("%s-%s", getLastName(), other.getLastName());
    setLastName(newLastName);
    other.setLastName(newLastName);
  }

  public Employer getEmployer() {
    return employer;
  }

  public void setEmployer(Employer e) {
    employer = e;
  }

  // methods delegated to EmployerImpl
  public Employee[] getEmployees() {
    return employerImpl.getEmployees();
  }

  public void addEmployee(Employee e) {
    employerImpl.addEmployee(e);
  }

  public void removeEmployee(Employee e) {
    employerImpl.removeEmployee(e);
  }

  public int employeeCount() {
    return employerImpl.getEmployees().length;
  }

}
