/***
 * Excerpted from "Rails For Java Programmers"
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/fr_r4j for more book information.
***/
package poly;

import java.util.ArrayList;

public class EmployerImpl implements Employer {
  private ArrayList employees;
  public EmployerImpl() {
    employees = new ArrayList();
  }

  public int employeeCount() {
    return employees.size();
  }

  public Employee[] getEmployees() {
    return (Employee []) employees.toArray(new Employee[employees.size()]);
  }

  public void addEmployee(Employee e) {
    Employer previous = e.getEmployer();
    if (previous != null) {
      previous.removeEmployee(e);
    }
    employees.add(e);
    e.setEmployer(this);
  }

  public void removeEmployee(Employee e) {
    employees.remove(e);
    e.setEmployer(null);
  }
}
