/***
 * Excerpted from "Rails For Java Programmers"
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/fr_r4j for more book information.
***/
package xml;

import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.*;

import javax.xml.parsers.*;
import java.io.*;
import java.util.ArrayList;

import junit.framework.TestCase;

public class SAXDemo extends TestCase {
  public void testSAX() throws Exception {
    Target[] t = getTargets(new File(Setup.SIMPLE_BUILD_FILE));
    assertEquals(3, t.length);
    assertEquals("clean", t[0].getName());
    assertNull(t[0].getDepends());
  }

  //START:SAX
  public Target[] getTargets(File file)
      throws ParserConfigurationException, SAXException, IOException {
    final ArrayList al = new ArrayList();
    SAXParserFactory f = SAXParserFactory.newInstance();
    SAXParser sp = f.newSAXParser();
    sp.parse(file, new DefaultHandler() {
      public void startElement(String uri, String lname,
                               String qname, Attributes attributes)
          throws SAXException {
        if (qname.equals("target")) {
          Target t = new Target();
          t.setDepends(attributes.getValue("depends"));
          t.setName(attributes.getValue("name"));
          al.add(t);
        }
      }
    });
    return (Target[]) al.toArray(new Target[al.size()]);
  }
  //END:SAX
}
