#---
# Excerpted from "Rails For Java Programmers"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_r4j for more book information.
#---
require File.dirname(__FILE__) + '/../test_helper'
require 'person_service_controller'

class PersonServiceController; def rescue_action(e) raise e end; end

class PersonServiceControllerApiTest < Test::Unit::TestCase
  fixtures :people
  
  def setup
    @controller = PersonServiceController.new
    @request    = ActionController::TestRequest.new
    @response   = ActionController::TestResponse.new
  end

  def test_get_person
    result = invoke :get_person, 1
    assert_equal people(:first), result
  end

  def test_save_person
    p = Person.new(:first_name=>'s', :last_name=>'h')
    # ActionWebService cannot handle this for some reason
    # result = invoke :save_person, p
    # assert_equal p.id, result
    result = @controller.save_person(p)
    assert_equal p.id, result
  end

  def test_delete_person
    result = invoke :delete_person, people(:first).id
    assert_equal true, result
  end

  def test_get_people
    result = invoke :get_people
    assert_equal [people(:first),people(:another)], result
  end
end
