#---
# Excerpted from "Rails For Java Programmers"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_r4j for more book information.
#---
require File.dirname(__FILE__) + '/../test_helper'

class PersonTest < Test::Unit::TestCase
  include FlexMock::TestCase
  def setup
    @p = PersonSweeper.send :new 
    @model = 1
    @args = {:controller=>'people', :id=>@model}
  end
  def test_after_save
    PersonSweeper::CACHED_ACTIONS.each do |action|
      flexstub(@p).should_receive(:expire_page).with(@args.merge(:action=>action))
    end
    @p.after_save(@model)
  end
  def test_after_destroy
    PersonSweeper::CACHED_ACTIONS.each do |action|
      flexstub(@p).should_receive(:expire_page).with(@args.merge(:action=>action))
    end
    @p.after_destroy(@model)
  end
end
