#---
# Excerpted from "Rails For Java Programmers"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_r4j for more book information.
#---
# This file is autogenerated. Instead of editing this file, please use the
# migrations feature of ActiveRecord to incrementally modify your database, and
# then regenerate this schema definition.

ActiveRecord::Schema.define(:version => 9) do

  create_table "authors", :force => true do |t|
    t.column "canonical",  :string
    t.column "legalname",  :string
    t.column "birthplace", :string
    t.column "birthdate",  :date
    t.column "deathdate",  :date
  end

  create_table "celestial_bodies", :force => true do |t|
    t.column "name",           :string
    t.column "type",           :string
    t.column "magnitude",      :integer, :limit => 10, :precision => 10, :scale => 0
    t.column "classification", :string,  :limit => 1
    t.column "gas_giant",      :boolean
    t.column "moons",          :integer
  end

  create_table "people", :force => true do |t|
    t.column "first_name",   :string
    t.column "last_name",    :string
    t.column "middle_name",  :string
    t.column "bio",          :text
    t.column "url",          :string
    t.column "lock_version", :integer, :default => 0
  end

  create_table "quips", :force => true do |t|
    t.column "text",         :text
    t.column "author_id",    :integer
    t.column "lock_version", :integer,  :default => 0
    t.column "created_at",   :datetime
    t.column "updated_at",   :datetime
  end

  create_table "roles", :force => true do |t|
    t.column "name",              :string,   :limit => 40
    t.column "authorizable_type", :string,   :limit => 30
    t.column "authorizable_id",   :integer
    t.column "created_at",        :datetime
    t.column "updated_at",        :datetime
  end

  create_table "roles_users", :id => false, :force => true do |t|
    t.column "user_id",    :integer
    t.column "role_id",    :integer
    t.column "created_at", :datetime
    t.column "updated_at", :datetime
  end

  create_table "sessions", :force => true do |t|
    t.column "session_id", :string
    t.column "data",       :text
    t.column "updated_at", :datetime
  end

  add_index "sessions", ["session_id"], :name => "index_sessions_on_session_id"
  add_index "sessions", ["updated_at"], :name => "index_sessions_on_updated_at"

  create_table "users", :force => true do |t|
    t.column "login",                     :string
    t.column "email",                     :string
    t.column "crypted_password",          :string,   :limit => 40
    t.column "salt",                      :string,   :limit => 40
    t.column "created_at",                :datetime
    t.column "updated_at",                :datetime
    t.column "remember_token",            :string
    t.column "remember_token_expires_at", :datetime
    t.column "lock_version",              :integer,                :default => 0
  end

end
