#---
# Excerpted from "Rails For Java Programmers"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_r4j for more book information.
#---
require 'rexml/parsers/sax2parser'
include REXML::Parsers


def get_targets(file)
  targets = []
  parser = SAX2Parser.new(file)
  parser.listen(:start_element, %w{target}) do |u,l,q,atts|
    targets << {:name=>atts['name'], :depends=>atts['depends']}
  end
  parser.parse
  targets
end


require 'test/unit'
class TestSAX < Test::Unit::TestCase
  @@xmlfile = File.join(File.dirname(__FILE__), '../../../Rake/simple_ant/build.xml')

  def test_get_targets
    assert_equal([{:depends=>nil, :name=>"clean"},
                  {:depends=>nil, :name=>"prepare"},
                  {:depends=>"prepare", :name=>"compile"}],
                 get_targets(File.new(@@xmlfile)))
  end
end