#---
# Excerpted from "Rails For Java Programmers"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_r4j for more book information.
#---

class AccessMe
  def initialize(name) 
    @name = name
    @stuff = []
  end
  attr_accessor :name

  protected 

  attr_accessor :stuff
  
  private 

  def clear
    @name = @stuff = nil
  end
end



a = AccessMe.new("test")
a.send :stuff=, 'some stuff'
puts a.send(:stuff)


begin

  a.send :stuff=, 'other stuff'
  a.stuff = 'better not try this'

rescue
end

require 'test/unit'
class AccessTest < Test::Unit::TestCase
  # Hack necessary to run tests inproc with Rails tests under rcov
  def load_fixtures; end
  
  def test_private
    a = AccessMe.new("test")
    assert_raise(NoMethodError) {a.clear}
  end
  
  def test_public
    a = AccessMe.new("test")
    assert_raise(NoMethodError) {a.stuff}
    class<<a; public :stuff; end
    assert_equal [], a.stuff
  end
  
  
  def test_clear
    AccessMe.send :public, :clear, :stuff
    a = AccessMe.new("test")
    a.clear
    assert_nil a.stuff
  end
  

  def teardown
    AccessMe.send :private, :clear
    AccessMe.send :protected, :stuff
  end
  
end

