#---
# Excerpted from "Rails For Java Programmers"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_r4j for more book information.
#---

require "#{File.dirname(__FILE__)}/../test_helper"

class QuipsSampleTest < ActionController::IntegrationTest
  fixtures :quips, :users, :roles, :roles_users


  
  def test_index_redirects_to_login
    get '/quips/index'
    assert_response :redirect
    follow_redirect!
    assert_response :success
    assert_template 'account/login'
  end
  
  
  
  def test_quentin_deletes_post
    user_session(:login=>:quentin, :password=>:test) do |quentin|
      quentin.logs_in
      quentin.destroys_quip(1)
    end
  end
  

  
  private

  module UserActions
    attr_accessor :credentials
    def logs_in
      post '/account/login', credentials
      assert_response :redirect
      follow_redirect!
      assert_response :success
      assert_template 'account/index'
    end
    
    def destroys_quip(id)
      post '/quips/destroy', :id=>id
      assert_response :redirect
      follow_redirect!
      assert_response :success
      assert_template 'quips/list'
    end
  end
  

  
  def user_session(credentials)
    open_session do |sess|
      sess.extend UserActions
      sess.credentials = credentials
      yield sess
    end
  end
  
  
end
