#---
# Excerpted from "Rails For Java Programmers"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_r4j for more book information.
#---
# This test requires that a server be running against the test environment ... hack

require File.dirname(__FILE__) + '/../test_helper'

# module to avoid collision with ActiveRecord Author
module Example
  
  class Author < ActiveResource::Base; end
  Author.site = 'http://localhost:3000'
  

  # more gyrations to avoid name collision with ActiveRecord Author
  Author.element_name = 'author'
  Author.collection_name = 'authors'

  class AuthorTest < Test::Unit::TestCase
    fixtures :authors
    self.use_transactional_fixtures = false
    
    AUTHOR_1_ATTS = {"birthplace"=>"MyString", 
                     "birthdate"=>Date.new(2006,11,01),
                     "canonical"=>"MyString", 
                     "id"=>1, 
                     "deathdate"=>Date.new(2006,11,01),
                     "legalname"=>"MyString"}
    def test_find
      
      a = Author.find(1)
      
      assert_equal AUTHOR_1_ATTS, a.attributes
    end

    def test_create
      
      a = Author.new :canonical=>'David Brin'
      a.save
      
      assert !a.new?
    end
    
    def test_update
      a = Author.find(1)
      a.canonical = 'Stanislaw Lem'
      a.save
      a.reload
      assert_equal 'Stanislaw Lem', a.canonical
    end

    def test_destroy
      a = Author.find(1)
      a.destroy
      assert_equal 1, ::Author.count
    end
  end
end

